local finalSkyMobj
local hellSkyMobj
local heavenSkyMobj
local portalSkyMobj

freeslot("sfx_stattp", "sfx_ddhvtp", "sfx_ddharp")

local function setPortalSky(line, mobj) 
	if mobj.player != nil then
		P_SetupLevelSky(0, mobj.player) 
		P_SetSkyboxMobj(portalSkyMobj, mobj.player)
	end
end

local function setHeavenSky(line, mobj) 
	if mobj.player != nil then
		P_SetupLevelSky(667, mobj.player) 
		P_SetSkyboxMobj(heavenSkyMobj, mobj.player)
	end
end

local function setHellSky(line, mobj) 
	if mobj.player != nil then
		P_SetupLevelSky(666, mobj.player) 
		P_SetSkyboxMobj(hellSkyMobj, mobj.player)
	end
end

local function setPurgSky(line, mobj)
	if mobj.player != nil then
		P_SetupLevelSky(461, mobj.player)
		P_SetSkyboxMobj(null, mobj.player)
	end
end

local function setFinalSky(line, mobj)
	if mobj.player != nil then
		P_SetupLevelSky(461, mobj.player)
		P_SetSkyboxMobj(finalSkyMobj, mobj.player)
	end
end

local randomOffset = 0
local effectLength = 35
local playersTarget = {}
local playersTarget2 = {}
local playersTarget3 = {}
local playersTpSpreadX = {}
local playersTpSpreadY = {}
local playersCounter = {}
local playersTransparency = {}
local playersTurn90 = {}

addHook("NetVars", function(net)
	playersTarget = net($)
	playersTarget2 = net($)
	playersTarget3 = net($)
	playersTpSpreadX = net($)
	playersTpSpreadY = net($)
	playersCounter = net($)
	playersTransparency = net($)
	playersTurn90 = net($)
end)

addHook("MapLoad", do
	

	if gamemap == 104 then
		for thing in mapthings.iterate do
			if thing.type == 780 then -- MT_SKYBOX then
				if thing.angle == 2 then
					finalSkyMobj = thing.mobj
				elseif thing.angle == 1 then
					heavenSkyMobj = thing.mobj
				elseif thing.angle == 0 then
					hellSkyMobj = thing.mobj
				elseif thing.angle == 5 then
					portalSkyMobj = thing.mobj
				end
			end
		end
		
		for p in players.iterate do
			--setHellSky(nil, p.mo)
		end
	end
end)

addHook("LinedefExecute", setHeavenSky, "HEAVNSKY")
addHook("LinedefExecute", setHellSky, "HLLSKY")
addHook("LinedefExecute", setFinalSky, "FINSKY")
addHook("LinedefExecute", setPurgSky, "PURSKY")
addHook("LinedefExecute", setPortalSky, "PRTLSKY")


addHook("LinedefExecute", function (line, mobj)
	if not mobj == player then return end
	
	-- check if user has no counter. start one if so
	-- also register destinations and other things
	if not playersCounter[#mobj.player] then
		playersCounter[#mobj.player] = effectLength * 2
		playersTarget[#mobj.player] = line.tag
		--playersTpSpreadX[#mobj.player] = line.backside.textureoffset
		--playersTpSpreadY[#mobj.player] = line.backside.rowoffset
		playersTpSpreadX[#mobj.player] = 256
		playersTpSpreadY[#mobj.player] = 256
		playersTarget2[#mobj.player] = FixedInt(line.frontside.textureoffset)
		playersTarget3[#mobj.player] = FixedInt(line.frontside.rowoffset)
		playersTurn90[#mobj.player] = line.flags
	end
end, "STATICTP")

addHook("LinedefExecute", function (line, mobj)
	if mobj.player then
		S_StartSound(mobj, sfx_ddhvtp, mobj.player)
	end
end, "HVNTPSND")

addHook("LinedefExecute", function (line, mobj)
	if mobj.player then
		S_StartSound(mobj, sfx_ddharp, mobj.player)
		P_FlashPal(mobj.player, PAL_MIXUP, 17)
	end
end, "HVNSND")

local function calculateTransparency(counter, length)
	-- this thing calculates a value between 4 and 16 to be used when multiplying
	-- against the alphamask constant
	
	-- that max is there because i fucked up somewhere and was too lazy to
	-- fix it. most certainly a gamer moment.
	return min(16, max(4, 16 - abs(
		FixedInt(
			FixedMul(
				FixedDiv(
					abs((counter - length)) * FRACUNIT, length * FRACUNIT
				),
				16 * FRACUNIT
			)
		)
	)))
end
addHook("ThinkFrame", do
	if leveltime < 3 then
		if leveltime == 2 then
			randomOffset = 0
			effectLength = 35
			playersTarget = {}
			playersTarget2 = {}
			playersTarget3 = {}
			playersTpSpreadX = {}
			playersTpSpreadY = {}
			playersCounter = {}
			playersTransparency = {}
			playersTurn90 = {}
		end
		
		return
	end

	if gamemap == 104 or gamemap == 103 then
		-- this is here since there's no random functions inside a hud event.
		randomOffset = P_RandomByte() 
		
		for player in players.iterate do	
			-- does this player have an active counter?
			if playersCounter[#player] ~= nil and playersCounter[#player] >= 0 then
				playersTransparency[#player] = calculateTransparency(playersCounter[#player], effectLength)
				playersCounter[#player] = max(0, playersCounter[#player] - 1)
			end
			
			if playersCounter[#player] == effectLength then
				
				local sectorTag = playersTarget[#player]
				if player.laps == 1 and playersTarget2[#player] then
					sectorTag = playersTarget2[#player]
				end
				if player.laps == 2 and playersTarget3[#player] then
					sectorTag = playersTarget3[#player]
				end
	
				
				for s in sectors.iterate do
					
					if s.tag == sectorTag then	
						
						for mobj in s.thinglist() do
							
							if mobj.type == MT_TPHELPER then
								local ofx = P_RandomRange(-playersTpSpreadX[#player], playersTpSpreadX[#player]) * FRACUNIT
								local ofy = P_RandomRange(-playersTpSpreadY[#player], playersTpSpreadY[#player]) * FRACUNIT
								ofx = ofx + mobj.x
								ofy = ofy + mobj.y
								
								P_SetOrigin(player.mo, ofx, ofy, 0)
								S_StartSound(player.mo, sfx_stattp, player)
								player.mo.angle = mobj.angle
								
								-- make the player invinc for a bit
								if player.kartstuff[k_hyudorotimer] < effectLength * 2 then
									player.kartstuff[k_hyudorotimer] = effectLength * 2
								end
								
								if playersTurn90[#player] == 1 then
									local oldMomx = player.mo.momx
									local oldMomy = player.mo.momy
									player.mo.momx = oldMomy
									player.mo.momy = -oldMomx
								end
							end
							
						end
						
					end
					
				end
			end
		end
	end
end)


hud.add(function(v, player, c)
	if gamemap ~= 103 and gamemap ~= 104 then return end
	
	if playersCounter[#player] == nil or playersCounter[#player] <= 0 then 
		return
	end
	
	local static = nil
	
	if gamemap == 104 then
		static = v.cachePatch("DDSTA0")
	end
	if gamemap == 103 then
		static = v.cachePatch("LLSTA0")
	end
	
	local offsetX = -255 - randomOffset
	local offsetY = -255 - randomOffset

	for x = offsetX, 640, 256 do
		for y = offsetY, 480, 256 do
			v.draw(x, y, static, V_ALPHAMASK * playersTransparency[#player])
		end
	end
	
end, "game")